// TaskbarProgress.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "TaskbarProgress.h"
#include <assert.h>
#include <shellapi.h>
#include "TB3\\TaskbarList3.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void				OnStart(HWND hWnd);
DWORD WINAPI		ThreadProc(LPVOID lpParameter);
HWND				CreateTooltip(HWND hWnd);
void				TooltipProgress(HWND hTooltip, UINT nPos, UINT nMax);
void				GetDesktopRect(RECT* pRect);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TASKBARPROGRESS, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_TASKBARPROGRESS));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TASKBARPROGRESS));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_TASKBARPROGRESS);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	INITCOMMONCONTROLSEX	sICC;

	switch (message)
	{
	case(WM_CREATE):
		sICC.dwSize	= sizeof(INITCOMMONCONTROLSEX);
		sICC.dwICC	= ICC_WIN95_CLASSES | ICC_BAR_CLASSES;
		InitCommonControlsEx(&sICC);
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case(ID_FILE_START):
			OnStart(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

void OnStart(HWND hWnd)
{
	DWORD	dwThreadID;
	HANDLE	hThread;
	
	EnableMenuItem(GetMenu(hWnd), ID_FILE_START, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	
	hThread = CreateThread(NULL, 0, ThreadProc, hWnd, 0, &dwThreadID);

	assert(hThread != NULL);
}

DWORD WINAPI ThreadProc(LPVOID lpParameter)
{
	HWND			hWnd = (HWND)lpParameter;	
	HWND			hTooltip	= NULL;
	ITaskbarList3*	pTaskbar	= NULL;	
	HRESULT			hResult;

	// inicializace COM
	hResult = CoInitialize(NULL);
	assert(hResult == S_OK);
	// ziskani pointer na rozhrani ITaskbarList3
	hResult = CoCreateInstance(CLSID_TaskbarList, NULL, CLSCTX_ALL, IID_ITaskbarList3, (void**)&pTaskbar);

	// pokud mame pointer na rozhrani, tak nastav stav zobrazovani
	if (pTaskbar != NULL) pTaskbar->SetProgressState(hWnd, TBPF_NORMAL);
	// jinak vytvor tootlip
	else hTooltip = CreateTooltip(hWnd);

	// zobrazovani prubehu 0 az 99
	for (int i = 0;i < 100;i++) {
		// pokud mame pointer na rozhrani, tak zobraz novou hodnotu
		if (pTaskbar != NULL) pTaskbar->SetProgressValue(hWnd, i, 100);
		// jinak zobrazuj prubeh v tooltipu
		else TooltipProgress(hTooltip, i, 100);
		// pockej 100ms
		Sleep(100);
	}

	// pokud jsme pracovali s rozhranim
	if (pTaskbar != NULL) {
		// tak nastav vychozi stav zobrazovani 
		pTaskbar->SetProgressState(hWnd, TBPF_NOPROGRESS);
		// a rozhrani uvolni
		pTaskbar->Release();
		pTaskbar = NULL;
	}
	// jinak zrus okno tooltipu
	else DestroyWindow(hTooltip);

	// povol polozku Start v menu
	EnableMenuItem(GetMenu(hWnd), ID_FILE_START, MF_BYCOMMAND | MF_ENABLED);

	// deinicializace COM
	CoUninitialize();

	return(0);
}

HWND CreateTooltip(HWND hWnd)
{
	TOOLINFO	sToolInfo;
	// vytvoreni okna tooltipu
	HWND		hTooltip = CreateWindowEx(0, TOOLTIPS_CLASS, NULL, WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,
											CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hWnd, NULL, hInst, NULL);	
	assert(hTooltip != NULL);
	// nastaveni okna jako TOPMOST
	::SetWindowPos(hTooltip, HWND_TOPMOST,0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);			
	// vyplneni struktury TOOLINFO (TTF_TRACK) a zatim zadny text
	sToolInfo.cbSize		= sizeof(TOOLINFO);
	sToolInfo.uFlags		= TTF_TRACK;
	sToolInfo.hwnd			= NULL;
	sToolInfo.hinst			= NULL;
	sToolInfo.uId			= 0;
	sToolInfo.lpszText		= L"";
	// inicializace velikosti okna tooltipu
	sToolInfo.rect.left		= 0;
	sToolInfo.rect.top		= 0;
	sToolInfo.rect.right	= 0;
	sToolInfo.rect.bottom	= 0;
	// nastaveni maximalni delky textu, jinak se provede zalomeni
	::SendMessage(hTooltip, TTM_SETMAXTIPWIDTH, 0, (LPARAM)650);
	// nastaveni titulku v tootltipu
	::SendMessage(hTooltip, TTM_SETTITLE, (WPARAM)TTI_INFO, (LPARAM)L"programujte.com");
	// registrace tipu 
	::SendMessage(hTooltip, TTM_ADDTOOL, 0, (LPARAM)(LPTOOLINFO)&sToolInfo);			

	return(hTooltip);
}

void TooltipProgress(HWND hTooltip, UINT nPos, UINT nMax)
{
	wchar_t		wzTemp[65];
	RECT		rtRect;
	RECT		rtScreen;
	TOOLINFO	sToolInfo;
	int			nLeft;
	int			nTop;
	
	assert(nMax != 0);
	// zobrazovany text - prubeh
	swprintf_s(wzTemp, 64, L"%u%%", (nPos * 100) / nMax);
	// vyplneni noveho obsahu TOOLINFO (s novym textem)
	sToolInfo.cbSize		= sizeof(TOOLINFO);
	sToolInfo.uFlags		= TTF_TRACK;
	sToolInfo.hwnd			= NULL;
	sToolInfo.hinst			= NULL;
	sToolInfo.uId			= 0;
	sToolInfo.lpszText		= wzTemp;
	// velikost oblasi se prizpusobi sama
	sToolInfo.rect.left		= 0;
	sToolInfo.rect.top		= 0;
	sToolInfo.rect.right	= 0;
	sToolInfo.rect.bottom	= 0;
	// zjisteni aktualni velikosti okna tooltipu
	GetWindowRect(hTooltip, &rtRect);
	// zjisteni okraju pracovni plochy
	GetDesktopRect(&rtScreen);
	// zjisteni leveho horniho bodu pro zobrazni okna tooltipu
	nLeft	= rtScreen.right - (rtRect.right - rtRect.left);
	nTop	= rtScreen.bottom	- (rtRect.bottom - rtRect.top);		
	// aktualizace textu tooltipu
	::SendMessage(hTooltip, TTM_UPDATETIPTEXT, 0, (LPARAM)(LPTOOLINFO)&sToolInfo);
	// nastaveni pozice tooltipu
	::SendMessage(hTooltip, TTM_TRACKPOSITION, 0, (LPARAM)MAKELONG(nLeft, nTop));
	// aktivace posunuti tooltipu
	::SendMessage(hTooltip, TTM_TRACKACTIVATE, true, (LPARAM)(LPTOOLINFO)&sToolInfo);
}

void GetDesktopRect(RECT* pRect)
{
	APPBARDATA	sData;
	HWND		hDesktop;

	assert(pRect != NULL);
	// handle plochy
	hDesktop = GetDesktopWindow();
	assert(hDesktop != NULL);
	// klientska oblast plochy
	GetClientRect(hDesktop, pRect);
	// zjisteni pozice a velikosti Taskbaru
	ZeroMemory((LPBYTE)&sData, sizeof(sData));
	sData.cbSize = sizeof(sData);
	SHAppBarMessage(ABM_GETTASKBARPOS, &sData);
	SHAppBarMessage(ABM_GETAUTOHIDEBAR, &sData);
	// podle jeho umisteni uprav i klientskou oblast plochy
	switch(sData.uEdge) {
		case(ABE_BOTTOM):
			pRect->bottom = sData.rc.top;
			break;
		case(ABE_LEFT):
			pRect->left = sData.rc.right;
			break;
		case(ABE_RIGHT):
			pRect->right = sData.rc.left;
			break;
		case(ABE_TOP):
			pRect->top = sData.rc.bottom;
			break;
	};	
}